#ifndef		_CH37X_LIB_H
#define		_CH37X_LIB_H

#ifdef __cplusplus
extern "C" {
#endif
	
//ӦòӿڵĹܴ
#define GetVersion			0x80000001
#define GetDeviceID			0x80000002
#define GetDeviceMsg		0x80000003
#define GetDeviceDes		0x80000004

// Async operation
#define START_BUFFERED_UPLOAD 0x80000005
#define STOP_BUFFERED_UPLOAD  0x80000006
#define QWERY_BUFFERED_UPLOAD 0x80000007

#define CH37X_BULK_UP 		0x80000008
#define CH37X_BULK_DOWN 	0x80000009
#define CH37X_INT_UP 		0x8000000a
#define CH37X_INT_DOWN 	    0x8000000b

// Sync operation
#define CH37X_SET_TIMEOUT   0x8000000c
#define CH37X_BULK_READ     0x8800000d
#define CH37X_BULK_WRITE    0x8000000e

	
/* extern functions */

// ɨ赱ǰϵͳȡ豸
extern int CH37XScanDevices();

// CH37X豸,ɹtrue
extern bool CH37XOpenDevice(
	unsigned long iIndex);    // ָCH37X豸

// رCH37X豸,ɹtrue
extern bool CH37XCloseDevice(
	unsigned long iIndex);    // ָCH37X豸

/* device and driver messages */

// ָCH37X豸ƵĻ,򷵻NULL
extern void *CH37XGetDeviceName(
	unsigned long iIndex);       // ָCH37X豸,0Ӧһ豸

extern bool CH37XTest(
	unsigned long iIndex);       // ָCH37X豸
// ȡ汾
extern bool CH37XGetDriverVersion(
	unsigned long iIndex,       // ָCH37X豸
	void *oBuffer);             // ָһ㹻Ļ,ڱ豸ID

// ȡ豸ID
extern bool CH37XGetDeviceID(
	unsigned long iIndex,       // ָCH37X豸
	unsigned int *id);          // ָһintͱ,ڱ豸ID,16λ-vid16λ-pid

// ȡ豸˵Ϣ
extern bool CH37XGetDeviceMsg(
	unsigned long iIndex,       // ָCH37X豸
	unsigned int *msg);         // ָһintͱ,ڱ˵Ϣ,ֱΪ˵㡢


// ȡ豸
extern bool CH37XGetDeviceDescr(
	unsigned long iIndex,       // ָCH37X豸
	char *version);             // ָһ㹻Ļ,ڱ

/* device data control */

// USBݶдĳʱ
extern bool CH37XSetTimeout (  
	unsigned long iIndex,           // ָCH37X豸
	unsigned long iWriteTimeout,    // ָUSBдݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
	unsigned long iReadTimeout);    // ָUSBȡݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)

extern bool CH37XSetBufUpload(
    unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
    bool enable);               // Ϊfalseֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе

// ȡݿ
extern bool CH37XReadData(  
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *oBuffer,              // ָһ㹻Ļ,ڱȡ
	unsigned long *ioLength);   // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


// ȡݿ
extern bool CH37XWriteData(  
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *iBuffer,              // ָһ,׼д
	unsigned long *ioLength);   // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


#ifdef __cplusplus
}
#endif

#endif		// _CH37X_LIB_H
